'***************************************************************************************
'*                                                                                     *
'*  Ganganzeige V1.1 by Ati mit einem Open-Micro                                       *
'*                                                                                     *
'***************************************************************************************

' --- Betriebssystem konfigurieren -----------------------------------------------------
include "om.def"                        ' Definitionen fuer Betriebssystem
RunOnErr = on                           ' bei Fehler Programm neustarten (Fehler in ERR)
PullUpA = 0                             ' Pull-Up-Widerstnde - aus
'---------------------------------------------------------------------------------------


'--- Definitionen der QT4 & QY4 Ports --------------------------------------------------
define Sensor         ad[1]             'A-Port1 / Eingang Sensor
define outputB      port[2]             'A-Port2 / BCD Ausgang B
define frei1        port[3]             'A-Port3
define outputC      port[4]             'A-Port4 / BCD Ausgang C
define outputD      port[5]             'A-Port5 / BCD Ausgang D
define outputA      port[6]             'A-Port6 / BCD Ausgang A
'---------------------------------------------------------------------------------------


'--- Initialisierung Hard und Software -------------------------------------------------
' Es werden jetzt nacheinander die Zahlen 0 bis 6 angezeigt. Danach begint dass
' eigentliche Programm.
'--------------------
Initial : pause 12				' Anzeige 8 auf dem Display
Leerlauf : pause 6                             ' Anzeige 0 auf dem Display
Gang_1 : pause 6                               ' Anzeige 1 auf dem Display
Gang_2 : pause 6                               ' Anzeige 2 auf dem Display
Gang_3 : pause 6                               ' Anzeige 3 auf dem Display
Gang_4 : pause 6                               ' Anzeige 4 auf dem Display
Gang_5 : pause 6                               ' Anzeige 5 auf dem Display
Gang_6 : pause 6                               ' Anzeige 6 auf dem Display
Fehler : pause 6                               ' Anzeige E auf dem Display
Display_aus : pause 12                          ' Anzeige aus laut Datenblatt B348
'---------------------------------------------------------------------------------------




'--- Hauptprogramm ---------------------------------------------------------------------
' Es wird nun alle 0,5 Sekunden der Gang-Sensor abgefragt.
'--------------------
#start                                          'Programmanfang
if Sensor>=83 and Sensor<=105 then
     gosub Gang_1                               'Anzeige - Gang 1
else if Sensor>=106 and Sensor<=128 then
     gosub Gang_2                               'Anzeige - Gang 2
else if Sensor>=129 and Sensor<=170 then
     gosub Gang_3                               'Anzeige - Gang 3
else if Sensor>=171 and Sensor<=197 then
     gosub Gang_4                               'Anzeige - Gang 4
else if Sensor>=198 and Sensor<=224 then
     gosub Gang_5                               'Anzeige - Gang 5
else if Sensor>=225 and Sensor<=243 then
     gosub Gang_6                               'Anzeige - Gang 6
else if Sensor>=244 then
     gosub Leerlauf                             'Anzeige - Leerlauf
else if Sensor>=0 and Sensor<82 then
     gosub Fehler                               'Anzeige - Error
end if
pause 12				        'Pause 240 Millisekunden
goto start                                      'zum Programmanfang
end
'---------------------------------------------------------------------------------------




'--- Display AUS -----------------------------------------------------------------------
' Es wird dass Display abgeschaltet (keine Zahlen sichtbar, es steht ein - )
'--------------------
FUNC Display_aus
  outputA = off                                 'BCD Pin-A = ein
  outputB = on                                  'BCD Pin-B = ein
  outputc = off                                 'BCD Pin-C = ein
  outputD = on                                  'BCD Pin-D = ein
  RETURN
END FUNC
'---------------------------------------------------------------------------------------


'--- Leerlauf --------------------------------------------------------------------------
' Es wird eine 0 auf dem Display angezeigt.
'--------------------
FUNC Leerlauf
  outputA = off                                 'BCD Pin-A = aus
  outputB = off                                 'BCD Pin-B = aus
  outputC = off                                 'BCD Pin-C = aus
  outputD = off                                 'BCD Pin-D = aus
  RETURN
END FUNC
'---------------------------------------------------------------------------------------


'--- Gang 1 ----------------------------------------------------------------------------
' Es wird eine 1 auf dem Display angezeigt.
'--------------------
FUNC Gang_1
  outputA = on                                  'BCD Pin-A = ein
  outputB = off                                 'BCD Pin-B = aus
  outputC = off                                 'BCD Pin-C = aus
  outputD = off                                 'BCD Pin-D = aus
  RETURN
END FUNC
'---------------------------------------------------------------------------------------


'--- Gang 2 ----------------------------------------------------------------------------
' Es wird eine 2 auf dem Display angezeigt.
'--------------------
FUNC Gang_2
  outputA = off                                 'BCD Pin-A = aus
  outputB = on                                  'BCD Pin-B = ein
  outputC = off                                 'BCD Pin-C = aus
  outputD = off                                 'BCD Pin-D = aus
  RETURN
END FUNC
'---------------------------------------------------------------------------------------


'--- Gang 3 ----------------------------------------------------------------------------
' Es wird eine 3 auf dem Display angezeigt.
'--------------------
FUNC Gang_3
  outputA = on                                  'BCD Pin-A = ein
  outputB = on                                  'BCD Pin-B = ein
  outputC = off                                 'BCD Pin-C = aus
  outputD = off                                 'BCD Pin-D = aus
  RETURN
END FUNC
'---------------------------------------------------------------------------------------


'--- Gang 4 ----------------------------------------------------------------------------
' Es wird eine 4 auf dem Display angezeigt.
'--------------------
FUNC Gang_4
  outputA = off                                 'BCD Pin-A = aus
  outputB = off                                 'BCD Pin-B = aus
  outputC = on                                  'BCD Pin-C = ein
  outputD = off                                 'BCD Pin-D = aus
  RETURN
END FUNC
'---------------------------------------------------------------------------------------


'--- Gang 5 ----------------------------------------------------------------------------
' Es wird eine 5 auf dem Display angezeigt.
'--------------------
FUNC Gang_5
  outputA = on                                  'BCD Pin-A = ein
  outputB = off                                 'BCD Pin-B = aus
  outputC = on                                  'BCD Pin-C = ein
  outputD = off                                 'BCD Pin-D = aus
  RETURN
END FUNC
'---------------------------------------------------------------------------------------


'--- Gang 6 ----------------------------------------------------------------------------
' Es wird eine 6 auf dem Display angezeigt.
'--------------------
FUNC Gang_6
  outputA = off                                 'BCD Pin-A = aus
  outputB = on                                  'BCD Pin-B = ein
  outputC = on                                  'BCD Pin-C = ein
  outputD = off                                 'BCD Pin-D = aus
  RETURN
END FUNC
'---------------------------------------------------------------------------------------

'---Initialisierung---------------------------------------------------------------------
' Es wird eine 8 auf dem Display angezeigt.
'-------------------
FUNC Initial
  outputA = off					'BCD Pin-A = aus
  outputB = off					'BCD Pin-B = aus
  outputC = off					'BCD Pin-C = aus
  outputD = on					'BCD Pin-D = ein
  RETURN
End FUNC
'---------------------------------------------------------------------------------------

'--- Fehler ----------------------------------------------------------------------------
' Es wird ein E fr Error auf dem Display angezeigt -> D348 bei 11
'--------------------
FUNC Fehler
  outputA = on                                 'BCD Pin-A = ein
  outputB = on                                 'BCD Pin-B = ein
  outputC = off                                'BCD Pin-C = aus
  outputD = on                                 'BCD Pin-D = ein
  RETURN
END FUNC
'---------------------------------------------------------------------------------------
